#cython: language_level=3

from .obitypes           cimport const_char_p, \
                                 OBIType_t, \
                                 obiversion_t, \
                                 index_t
from ..capi.obidms       cimport OBIDMS_p
from ..capi.obidmscolumn cimport OBIDMS_column_p


cdef extern from "obiview.h" nogil:

    struct Column_reference_t :
        char          column_name
        obiversion_t  version
    
    ctypedef Column_reference_t* Column_reference_p


    struct Obiview_t :
        OBIDMS_p            dms
        const_char_p        name
        OBIDMS_column_p     line_selection
        OBIDMS_column_p     new_line_selection
        OBIDMS_column_p     columns
        bint                read_only
        Column_reference_t  line_selection_reference
        index_t             line_count
        int                 column_count

    ctypedef Obiview_t* Obiview_p


    Obiview_p obi_new_view(OBIDMS_p dms, const_char_p view_name, Obiview_p view_to_clone, index_t* line_selection)
    
    Obiview_p obi_new_view_cloned_from_name(OBIDMS_p dms, const char* view_name, const char* view_to_clone_name, index_t* line_selection)

    Obiview_p obi_open_view(OBIDMS_p dms, const_char_p view_name)
    
    int obi_view_add_column(Obiview_p view,
                            const_char_p column_name,
                            obiversion_t version_number,
                            OBIType_t data_type,
                            index_t nb_lines,
                            index_t nb_elements_per_line,
                            const_char_p elements_names,
                            const_char_p avl_name,
                            const_char_p comments,
                            bint create)

    int obi_view_delete_column(Obiview_p view, const_char_p column_name)
    
    int obi_select_line(Obiview_p view, index_t line_nb)

    int obi_select_lines(Obiview_p view, index_t* line_nbs)

    OBIDMS_column_p obi_view_clone_column(Obiview_p view, const_char_p column_name)
        
    OBIDMS_column_p obi_view_get_column(Obiview_p view, const_char_p column_name)

    OBIDMS_column_p* obi_view_get_pointer_on_column_in_view(Obiview_p view, const_char_p column_name)

    int obi_save_view(Obiview_p view)
    
    int obi_close_view(Obiview_p view)
    
    int obi_save_and_close_view(Obiview_p view)

